Add "Attoparsec" to the optional haskell packages
[ganeti-github.git] / INSTALL
1 Ganeti quick installation guide
2 ===============================
3
4 Please note that a more detailed installation procedure is described in
5 the :doc:`install`. A glossary of terms can be found in the
6 :doc:`glossary`.
7
8
9 Software Requirements
10 ---------------------
11
12 .. highlight:: shell-example
13
14 Before installing, please verify that you have the following programs:
15
16 - `Xen Hypervisor <http://www.xen.org/>`_, version 3.0 or above, if
17   running on Xen
18 - `KVM Hypervisor <http://www.linux-kvm.org>`_, version 72 or above, if
19   running on KVM. In order to use advanced features, such as live
20   migration, virtio, etc, an even newer version is recommended (qemu-kvm
21   versions 0.11.X and above have shown good behavior).
22 - `DRBD <http://www.drbd.org/>`_, kernel module and userspace utils,
23   version 8.0.7 or above; note that Ganeti doesn't yet support version 8.4
24 - `RBD <http://ceph.newdream.net/>`_, kernel modules
25   (``rbd.ko``/``libceph.ko``) and userspace utils (``ceph-common``)
26 - `LVM2 <http://sourceware.org/lvm2/>`_
27 - `OpenSSH <http://www.openssh.com/portable.html>`_
28 - `bridge utilities <http://www.linuxfoundation.org/en/Net:Bridge>`_
29 - `iproute2 <http://www.linuxfoundation.org/en/Net:Iproute2>`_
30 - `arping <http://www.skbuff.net/iputils/>`_ (part of iputils)
31 - `ndisc6 <http://www.remlab.net/ndisc6/>`_ (if using IPv6)
32 - `Python <http://www.python.org/>`_, version 2.4 or above, not 3.0
33 - `Python OpenSSL bindings <http://pyopenssl.sourceforge.net/>`_
34 - `simplejson Python module <http://code.google.com/p/simplejson/>`_
35 - `pyparsing Python module <http://pyparsing.wikispaces.com/>`_, version
36   1.4.6 or above
37 - `pyinotify Python module <http://trac.dbzteam.org/pyinotify/>`_
38 - `PycURL Python module <http://pycurl.sourceforge.net/>`_
39 - `ctypes Python module
40   <http://starship.python.net/crew/theller/ctypes/>`_, if running on
41   python 2.4 (optional, used for node daemon memory locking)
42 - `socat <http://www.dest-unreach.org/socat/>`_, see :ref:`note
43   <socat-note>` below
44 - `Paramiko <http://www.lag.net/paramiko/>`_, if you want to use
45   ``ganeti-listrunner``
46 - `affinity Python module <http://pypi.python.org/pypi/affinity/0.1.0>`_,
47   optional python package for supporting CPU pinning under KVM
48 - `ElementTree Python module <http://effbot.org/zone/element-index.htm>`_,
49   if running on python 2.4 (optional, used by the ``ovfconverter`` tool)
50 - `qemu-img <http://qemu.org/>`_, if you want to use ``ovfconverter``
51 - `fping <http://fping.sourceforge.net/>`_
52
53 These programs are supplied as part of most Linux distributions, so
54 usually they can be installed via the standard package manager. Also
55 many of them will already be installed on a standard machine. On
56 Debian/Ubuntu, you can use this command line to install all required
57 packages, except for RBD, DRBD and Xen::
58
59   $ apt-get install lvm2 ssh bridge-utils iproute iputils-arping \
60                     ndisc6 python python-pyopenssl openssl \
61                     python-pyparsing python-simplejson \
62                     python-pyinotify python-pycurl socat fping
63
64 Note that this does not install optional packages::
65
66   $ apt-get install python-paramiko python-affinity qemu-img
67
68 If some of the python packages are not available in your system,
69 you can try installing them using ``easy_install`` command.
70 For example::
71
72   $ apt-get install python-setuptools
73   $ cd / && sudo easy_install \
74             affinity
75
76
77 On Fedora to install all required packages except RBD, DRBD and Xen::
78
79   $ yum install openssh openssh-clients bridge-utils iproute ndisc6 \
80                 pyOpenSSL pyparsing python-simplejson python-inotify \
81                 python-lxm socat fping
82
83 For optional packages use the command::
84
85   $ yum install python-paramiko python-affinity qemu-img
86
87 If you want to build from source, please see doc/devnotes.rst for more
88 dependencies.
89
90 .. _socat-note:
91 .. note::
92   Ganeti's import/export functionality uses ``socat`` with OpenSSL for
93   transferring data between nodes. By default, OpenSSL 0.9.8 and above
94   employ transparent compression of all data using zlib if supported by
95   both sides of a connection. In cases where a lot of data is
96   transferred, this can lead to an increased CPU usage. Additionally,
97   Ganeti already compresses all data using ``gzip`` where it makes sense
98   (for inter-cluster instance moves).
99
100   To remedey this situation, patches implementing a new ``socat`` option
101   for disabling OpenSSL compression have been contributed and will
102   likely be included in the next feature release. Until then, users or
103   distributions need to apply the patches on their own.
104
105   Ganeti will use the option if it's detected by the ``configure``
106   script; auto-detection can be disabled by explicitly passing
107   ``--enable-socat-compress`` (use the option to disable compression) or
108   ``--disable-socat-compress`` (don't use the option).
109
110   The patches and more information can be found on
111   http://www.dest-unreach.org/socat/contrib/socat-opensslcompress.html.
112
113 Haskell requirements
114 ~~~~~~~~~~~~~~~~~~~~
115
116 Starting with Ganeti 2.7, the Haskell GHC compiler and a few base
117 libraries are required in order to build Ganeti (but not to run and
118 deploy Ganeti on production machines). More specifically:
119
120 - `GHC <http://www.haskell.org/ghc/>`_ version 6.12 or higher
121 - or even better, `The Haskell Platform
122   <http://hackage.haskell.org/platform/>`_ which gives you a simple way
123   to bootstrap Haskell
124 - `json <http://hackage.haskell.org/package/json>`_, a JSON library
125 - `network <http://hackage.haskell.org/package/network>`_, a basic
126   network library
127 - `parallel <http://hackage.haskell.org/package/parallel>`_, a parallel
128   programming library (note: tested with up to version 3.x)
129 - `bytestring <http://hackage.haskell.org/package/bytestring>`_ and
130   `utf8-string <http://hackage.haskell.org/package/utf8-string>`_
131   libraries; these usually come with the GHC compiler
132 - `deepseq <http://hackage.haskell.org/package/deepseq>`_
133
134 Some of these are also available as package in Debian/Ubuntu::
135
136   $ apt-get install ghc6 libghc6-json-dev libghc6-network-dev \
137                     libghc6-parallel-dev libghc6-deepseq-dev
138
139 Or in newer versions of these distributions (using GHC 7.x)::
140
141   $ apt-get install ghc libghc-json-dev libghc-network-dev \
142                     libghc-parallel-dev  libghc-deepseq-dev \
143                     libghc-utf8-string-dev
144
145 In Fedora, they are available via packages as well::
146
147   $ yum install ghc ghc-json-devel ghc-network-devel \
148                     ghc-parallel-devel ghc-deepseq-devel
149
150 If using a distribution which does not provide them, first install
151 the Haskell platform. You can also install ``cabal`` manually::
152
153   $ apt-get install cabal-install
154
155 Then install the additional libraries via
156 ``cabal``::
157
158   $ cabal install json network parallel utf8-string
159
160 The compilation of the htools components is automatically enabled when
161 the compiler and the requisite libraries are found. You can use the
162 ``--enable-htools`` configure flag to force the selection (at which
163 point ``./configure`` will fail if it doesn't find the prerequisites).
164
165
166 Haskell optional features
167 ~~~~~~~~~~~~~~~~~~~~~~~~~
168
169 Optionally, more functionality can be enabled if your build machine has
170 a few more Haskell libraries enabled: RAPI access to remote cluster from
171 htools (``--enable-htools-rapi``), the ``ganeti-confd``
172 daemon (``--enable-confd``) and the monitoring agent
173 (``--enable-monitoring``). The list of extra dependencies for these is:
174
175 - `curl <http://hackage.haskell.org/package/curl>`_, tested with
176   versions 1.3.4 and above
177 - `hslogger <http://software.complete.org/hslogger>`_, version 1.1 and
178   above (note that Debian Squeeze only has version 1.0.9)
179 - `Crypto <http://hackage.haskell.org/package/Crypto>`_, tested with
180   version 4.2.4
181 - `text <http://hackage.haskell.org/package/text>`_
182 - `hinotify <http://hackage.haskell.org/package/hinotify>`_
183 - `regex-pcre <http://hackage.haskell.org/package/regex-pcre>`_,
184   bindings for the ``pcre`` library
185 - `attoparsec <http://hackage.haskell.org/package/attoparsec>`_
186
187 These libraries are available in Debian Wheezy (but not in Squeeze, with
188 the exception of curl), so you can use either apt::
189
190   $ apt-get install libghc-hslogger-dev libghc-crypto-dev libghc-text-dev \
191                     libghc-hinotify-dev libghc-regex-pcre-dev libghc-curl-dev \
192                     libghc-attoparsec-dev
193
194 or ``cabal``::
195
196   $ cabal install hslogger Crypto text hinotify regex-pcre curl \
197                   attoparsec
198
199 to install them.
200
201 The most recent Fedora doesn't provide ``curl``, ``crypto``,
202 ``inotify``. So these need to be installed using ``cabal``, if
203 desired. The other packages can be installed via ``yum``::
204
205   $ yum install ghc-hslogger-devel ghc-text-devel \
206                 ghc-regex-pcre-devel
207
208 .. _cabal-note:
209 .. note::
210   If one of the cabal packages fails to install due to unfulfilled
211   dependencies, you can try enabling symlinks in ``~/.cabal/config``.
212
213   Make sure that your ``~/.cabal/bin`` directory (or whatever else
214   is defined as ``bindir``) is in your ``PATH``.
215
216 Installation of the software
217 ----------------------------
218
219 To install, simply run the following command::
220
221   $ ./configure --localstatedir=/var --sysconfdir=/etc && \
222     make && \
223     make install
224
225 This will install the software under ``/usr/local``. You then need to
226 copy ``doc/examples/ganeti.initd`` to ``/etc/init.d/ganeti`` and
227 integrate it into your boot sequence (``chkconfig``, ``update-rc.d``,
228 etc.).
229
230
231 Cluster initialisation
232 ----------------------
233
234 Before initialising the cluster, on each node you need to create the
235 following directories:
236
237 - ``/etc/ganeti``
238 - ``/var/lib/ganeti``
239 - ``/var/log/ganeti``
240 - ``/srv/ganeti``
241 - ``/srv/ganeti/os``
242 - ``/srv/ganeti/export``
243
244 After this, use ``gnt-cluster init``.
245
246 .. vim: set textwidth=72 syntax=rst :
247 .. Local Variables:
248 .. mode: rst
249 .. fill-column: 72
250 .. End: